/**
 * JavaScript for the CryptoPhoto extension.
 * 
 * @author CryptoPhoto
 */

if (typeof CPPluginWizard !== 'object') CPPluginWizard = {};

CPPluginWizard.serverip = drupalSettings.cryptophoto.svip;
CPPluginWizard.callback = function(keys) {

  if(keys.PRIVATE_KEY && keys.PUBLIC_KEY) {
    document.getElementById("publickey").value = keys.PUBLIC_KEY;
    document.getElementById("privatekey").value = keys.PRIVATE_KEY;
    if (!!!document.getElementById("salt").value) {
      document.getElementById("salt").value = guid();
    }
    //testConfig();
  }

};

//Browser Support Code
function testConfig() {

  var ajaxRequest;  // The variable that makes Ajax possible!
  
  try {
    // Opera 8.0+, Firefox, Safari
    ajaxRequest = new XMLHttpRequest();
  } catch (e) {
    // Internet Explorer Browsers
    try {
      ajaxRequest = new ActiveXObject("Msxml2.XMLHTTP");
    } catch (e) {
      try {
        ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");
      } catch (e) {
        // Something went wrong
        return false;
      }
    }
  }
  
  
  // Create a function that will receive data sent from the server
  ajaxRequest.onreadystatechange = function() {
  
    if(ajaxRequest.readyState == 4 && ajaxRequest.status == 200) {
      document.getElementById("testresult").innerHTML=ajaxRequest.responseText;

      if(ajaxRequest.responseText.indexOf('success') > -1) {
        document.getElementById("testresult").innerHTML="Cryptophoto plugin is configured properly.";
        document.getElementById("testresult").setAttribute("style","color:green"); 
      }
      else if(ajaxRequest.responseText.indexOf('timestamp') > -1) {
        document.getElementById("testresult").innerHTML="Error: Please verify that the date/time is properly set on this server.";
        document.getElementById("testresult").setAttribute("style","color:red"); 
      }
      else if(ajaxRequest.responseText.indexOf('ip') > -1) {
        var ip = "";
        ip = ajaxRequest.responseText.replace("ip ","");

        if (ip) { 
          ip = " (" + ip +")";
        } 
        else {
          ip = "";
        }

        document.getElementById("testresult").innerHTML="Error: The IP of this server"+ip+" is not added to the list of allowed IPs. Check your settings in your CryptoPhoto.com account.";
        document.getElementById("testresult").setAttribute("style","color:red"); 
      }
      else if(ajaxRequest.responseText.indexOf('invalid') > -1) {
        document.getElementById("testresult").innerHTML="Error: Please verify that the API keys are valid.";
       document.getElementById("testresult").setAttribute("style","color:red"); 
      }
      else if(ajaxRequest.responseText.indexOf('empty') > -1) {
       document.getElementById("testresult").innerHTML="Error: Please configure and save your API keys and salt.";
       document.getElementById("testresult").setAttribute("style","color:red"); 
      }
      else {
        document.getElementById("testresult").innerHTML="Error: Unknown error. Please check your CryptoPhoto server setting.";
        document.getElementById("testresult").setAttribute("style","color:red"); 
      }
    }
  };

  var data = "test=1";
  data += "&publickey=" + encodeURIComponent(document.getElementById("publickey").value);
  data += "&privatekey=" + encodeURIComponent(document.getElementById("privatekey").value);
  data += "&salt=" + encodeURIComponent(document.getElementById("salt").value);
  data += "&server=" + encodeURIComponent(document.getElementById("server").value);
  
  ajaxRequest.open("POST", drupalSettings.cryptophoto.base_url + "/admin/config/cryptophoto/settings_test", true);
  ajaxRequest.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
  ajaxRequest.send(data);
}

function guid() {
  var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split(''); 
  var uuid = new Array(36), rnd=0, r;
  for (var i = 0; i < 36; i++) {
    if (i==8 || i==13 ||  i==18 || i==23) {
      uuid[i] = '';
    } else if (i==14) {
      uuid[i] = '4';
    } else {
      if (rnd <= 0x02) rnd = 0x2000000 + (Math.random()*0x1000000)|0;
      r = rnd & 0xf;
      rnd = rnd >> 4;
      uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r];
    }
  }
  return uuid.join('');
}

function add_script (a) {
  var b = document.createElement("script");
  b.type = "text/javascript";
  b.src = a;
  document.body.appendChild(b);
}

var server = document.getElementById("server").value;
if(server.indexOf("http") > -1) {
  add_script(server+"/api/plugin/config.js");
} 
